Index: kernel/tgb.cc
===================================================================
--- kernel/tgb.cc	(revision a41623dd1e56318466dc81751481d37d19489c7b)
+++ kernel/tgb.cc	(revision 410ea0fb1e22ebcb52e33b6789cf294a2d1f663b)
@@ -4119,150 +4489,162 @@
       if (c->eliminationProblem)
       {
-        tdeg_full=c->pTotaldegree_full(clear_into);
-        tdeg=c->pTotaldegree(clear_into);
-      }
-    }
-    c->strat->S[j]=clear_into;
-    c->strat->lenS[j]=new_length;
-
-    assume(pLength(clear_into)==new_length);
-    if(c->strat->lenSw!=NULL)
-      c->strat->lenSw[j]=qal;
-    if (!rField_is_Zp(c->r))
-    {
-      p_Cleardenom(clear_into,c->r);//should be unnecessary
+	tdeg_full = c->pTotaldegree_full (clear_into);
+	tdeg = c->pTotaldegree (clear_into);
+      }
+    }
+    c->strat->S[j] = clear_into;
+    c->strat->lenS[j] = new_length;
+
+    assume (pLength (clear_into) == new_length);
+    if (c->strat->lenSw != NULL)
+      c->strat->lenSw[j] = qal;
+    if (!rField_is_Zp (c->r))
+    {
+      p_Cleardenom (clear_into, c->r);	//should be unnecessary
       //p_Content(clear_into, c->r);
     }
     else
-      pNorm(clear_into);
+      pNorm (clear_into);
 #ifdef FIND_DETERMINISTIC
-    erg.reduce_by=j;
+    erg.reduce_by = j;
     //resort later see diploma thesis, find_in_S must be deterministic
     //during multireduction if spolys are only in the span of the
     //input polys
 #else
-    if (new_pos<j)
-    {
-      if (c->strat->honey) c->strat->ecartS[j]=tdeg_full-tdeg;
-      move_forward_in_S(j,new_pos,c->strat);
-      erg.reduce_by=new_pos;
-    }
-#endif
-  }
-}
-
-static int fwbw(red_object* los, int i)
-{
-   int i2=i;
-   int step=1;
-
-   BOOLEAN bw=FALSE;
-   BOOLEAN incr=TRUE;
-
-   while(1)
-   {
-     if(!bw)
-     {
-       step=si_min(i2,step);
-       if (step==0) break;
-       i2-=step;
-
-       if(!pLmEqual(los[i].p,los[i2].p))
-       {
-   bw=TRUE;
-   incr=FALSE;
-       }
-       else
-       {
-   if ((!incr) &&(step==1)) break;
-       }
-     }
-     else
-     {
-       step=si_min(i-i2,step);
-       if (step==0) break;
-       i2+=step;
-       if(pLmEqual(los[i].p,los[i2].p))
-       {
-   if(step==1) break;
-   else
-   {
-     bw=FALSE;
-   }
-       }
-     }
-     if (incr)
-       step*=2;
-     else
-     {
-       if (step%2==1)
-   step=(step+1)/2;
-       else
-   step/=2;
-     }
-   }
-   return i2;
-}
-
-static void canonicalize_region(red_object* los, int l, int u,slimgb_alg* c)
-{
-    assume(l<=u+1);
-    int i;
-    for(i=l;i<=u;i++)
-    {
-        kBucketCanonicalize(los[i].bucket);
-    }
-}
-static void multi_reduction_find(red_object* los, int losl,slimgb_alg* c,int startf,find_erg & erg)
-{
-  kStrategy strat=c->strat;
-
-  assume(startf<=losl);
-  assume((startf==losl-1)||(pLmCmp(los[startf].p,los[startf+1].p)==-1));
-  int i=startf;
+    if (new_pos < j)
+    {
+      if (c->strat->honey)
+	c->strat->ecartS[j] = tdeg_full - tdeg;
+      move_forward_in_S (j, new_pos, c->strat);
+      erg.reduce_by = new_pos;
+    }
+#endif
+  }
+}
+
+static int
+fwbw (red_object * los, int i)
+{
+  int i2 = i;
+  int step = 1;
+
+  BOOLEAN bw = FALSE;
+  BOOLEAN incr = TRUE;
+
+  while (1)
+  {
+    if (!bw)
+    {
+      step = si_min (i2, step);
+      if (step == 0)
+	break;
+      i2 -= step;
+
+      if (!pLmEqual (los[i].p, los[i2].p))
+      {
+	bw = TRUE;
+	incr = FALSE;
+      }
+      else
+      {
+	if ((!incr) && (step == 1))
+	  break;
+      }
+    }
+    else
+    {
+      step = si_min (i - i2, step);
+      if (step == 0)
+	break;
+      i2 += step;
+      if (pLmEqual (los[i].p, los[i2].p))
+      {
+	if (step == 1)
+	  break;
+	else
+	{
+	  bw = FALSE;
+	}
+      }
+    }
+    if (incr)
+      step *= 2;
+    else
+    {
+      if (step % 2 == 1)
+	step = (step + 1) / 2;
+      else
+	step /= 2;
+    }
+  }
+  return i2;
+}
+
+static void
+canonicalize_region (red_object * los, int l, int u, slimgb_alg * c)
+{
+  assume (l <= u + 1);
+  int i;
+  for (i = l; i <= u; i++)
+  {
+    kBucketCanonicalize (los[i].bucket);
+  }
+}
+
+static void
+multi_reduction_find (red_object * los, int losl, slimgb_alg * c, int startf,
+		      find_erg & erg)
+{
+  kStrategy strat = c->strat;
+
+  assume (startf <= losl);
+  assume ((startf == losl - 1)
+	  || (pLmCmp (los[startf].p, los[startf + 1].p) == -1));
+  int i = startf;
 
   int j;
-  while(i>=0)
-  {
-    assume((i==losl-1)||(pLmCmp(los[i].p,los[i+1].p)<=0));
-    assume(is_valid_ro(los[i]));
-    assume((!(c->eliminationProblem))||(los[i].sugar>=c->pTotaldegree(los[i].p)));
-    j=kFindDivisibleByInS_easy(strat,los[i]);
-    if(j>=0)
-    {
-      erg.to_reduce_u=i;
-      erg.reduce_by=j;
-      erg.fromS=TRUE;
-      int i2=fwbw(los,i);
-      assume(pLmEqual(los[i].p,los[i2].p));
-      assume((i2==0)||(!pLmEqual(los[i2].p,los[i2-1].p)));
-      assume(i>=i2);
-
-      erg.to_reduce_l=i2;
-      assume((i==losl-1)||(pLmCmp(los[i].p,los[i+1].p)==-1));
-      canonicalize_region(los,erg.to_reduce_u+1,startf,c);
+  while (i >= 0)
+  {
+    assume ((i == losl - 1) || (pLmCmp (los[i].p, los[i + 1].p) <= 0));
+    assume (is_valid_ro (los[i]));
+    assume ((!(c->eliminationProblem))
+	    || (los[i].sugar >= c->pTotaldegree (los[i].p)));
+    j = kFindDivisibleByInS_easy (strat, los[i]);
+    if (j >= 0)
+    {
+      erg.to_reduce_u = i;
+      erg.reduce_by = j;
+      erg.fromS = TRUE;
+      int i2 = fwbw (los, i);
+      assume (pLmEqual (los[i].p, los[i2].p));
+      assume ((i2 == 0) || (!pLmEqual (los[i2].p, los[i2 - 1].p)));
+      assume (i >= i2);
+
+      erg.to_reduce_l = i2;
+      assume ((i == losl - 1) || (pLmCmp (los[i].p, los[i + 1].p) == -1));
+      canonicalize_region (los, erg.to_reduce_u + 1, startf, c);
       return;
     }
-    if (j<0)
+    if (j < 0)
     {
       //not reduceable, try to use this for reducing higher terms
-      int i2=fwbw(los,i);
-      assume(pLmEqual(los[i].p,los[i2].p));
-      assume((i2==0)||(!pLmEqual(los[i2].p,los[i2-1].p)));
-      assume(i>=i2);
-      if(i2!=i)
-      {
-  erg.to_reduce_u=i-1;
-  erg.to_reduce_l=i2;
-  erg.reduce_by=i;
-  erg.fromS=FALSE;
-  assume((i==losl-1)||(pLmCmp(los[i].p,los[i+1].p)==-1));
-  canonicalize_region(los,erg.to_reduce_u+1,startf,c);
-  return;
+      int i2 = fwbw (los, i);
+      assume (pLmEqual (los[i].p, los[i2].p));
+      assume ((i2 == 0) || (!pLmEqual (los[i2].p, los[i2 - 1].p)));
+      assume (i >= i2);
+      if (i2 != i)
+      {
+	erg.to_reduce_u = i - 1;
+	erg.to_reduce_l = i2;
+	erg.reduce_by = i;
+	erg.fromS = FALSE;
+	assume ((i == losl - 1) || (pLmCmp (los[i].p, los[i + 1].p) == -1));
+	canonicalize_region (los, erg.to_reduce_u + 1, startf, c);
+	return;
       }
       i--;
     }
   }
-  erg.reduce_by=-1;//error code
+  erg.reduce_by = -1;		//error code
   return;
 }
@@ -4273,90 +4655,99 @@
 //   {
 
-static int multi_reduction_clear_zeroes(red_object* los, int  losl, int l, int u)
-{
-  int deleted=0;
-  int  i=l;
-  int last=-1;
-  while(i<=u)
-  {
-    if(los[i].p==NULL)
-    {
-      kBucketDestroy(&los[i].bucket);
+static int
+multi_reduction_clear_zeroes (red_object * los, int losl, int l, int u)
+{
+  int deleted = 0;
+  int i = l;
+  int last = -1;
+  while (i <= u)
+  {
+    if (los[i].p == NULL)
+    {
+      kBucketDestroy (&los[i].bucket);
 //      delete los[i];//here we assume los are constructed with new
       //destroy resources, must be added here
-     if (last>=0)
-     {
-       memmove(los+(int)(last+1-deleted),los+(last+1),sizeof(red_object)*(i-1-last));
-     }
-     last=i;
-     deleted++;
+      if (last >= 0)
+      {
+	memmove (los + (int) (last + 1 - deleted), los + (last + 1),
+		 sizeof (red_object) * (i - 1 - last));
+      }
+      last = i;
+      deleted++;
     }
     i++;
   }
-  if((last>=0)&&(last!=losl-1))
-      memmove(los+(int)(last+1-deleted),los+last+1,sizeof(red_object)*(losl-1-last));
+  if ((last >= 0) && (last != losl - 1))
+    memmove (los + (int) (last + 1 - deleted), los + last + 1,
+	     sizeof (red_object) * (losl - 1 - last));
   return deleted;
 }
 
-int search_red_object_pos(red_object* a, int top, red_object* key )
-{
-    int an = 0;
-    int en= top;
-    if (top==-1) return 0;
-    if (pLmCmp(key->p,a[top].p)==1)
-      return top+1;
-    int i;
-    loop
-    {
-      if (an >= en-1)
-      {
-        if (pLmCmp(key->p,a[an].p)==-1)
-           return an;
-        return en;
-      }
-      i=(an+en) / 2;
-      if (pLmCmp(key->p,a[i].p)==-1)
-        en=i;
-      else
-        an=i;
-    }
-}
-
-static void sort_region_down(red_object* los, int l, int u, slimgb_alg* c)
-{
-  int r_size=u-l+1;
-  qsort(los+l,r_size,sizeof(red_object),red_object_better_gen);
+int
+search_red_object_pos (red_object * a, int top, red_object * key)
+{
+  int an = 0;
+  int en = top;
+  if (top == -1)
+    return 0;
+  if (pLmCmp (key->p, a[top].p) == 1)
+    return top + 1;
   int i;
-  int * new_indices=(int*) omalloc((r_size)*sizeof(int));
-  int bound=0;
-  BOOLEAN at_end=FALSE;
-  for(i=l;i<=u;i++)
+  loop
+  {
+    if (an >= en - 1)
+    {
+      if (pLmCmp (key->p, a[an].p) == -1)
+	return an;
+      return en;
+    }
+    i = (an + en) / 2;
+    if (pLmCmp (key->p, a[i].p) == -1)
+      en = i;
+    else
+      an = i;
+  }
+}
+
+static void
+sort_region_down (red_object * los, int l, int u, slimgb_alg * c)
+{
+  int r_size = u - l + 1;
+  qsort (los + l, r_size, sizeof (red_object), red_object_better_gen);
+  int i;
+  int *new_indices = (int *) omalloc ((r_size) * sizeof (int));
+  int bound = 0;
+  BOOLEAN at_end = FALSE;
+  for (i = l; i <= u; i++)
   {
     if (!(at_end))
     {
-      bound=new_indices[i-l]=bound+search_red_object_pos(los+bound,l-bound-1,los+i);
-      if (bound==l) at_end=TRUE;
+      bound = new_indices[i - l] =
+	bound + search_red_object_pos (los + bound, l - bound - 1, los + i);
+      if (bound == l)
+	at_end = TRUE;
     }
     else
     {
-      new_indices[i-l]=l;
-    }
-  }
-  red_object* los_region=(red_object*) omalloc(sizeof(red_object)*(u-l+1));
-  for (int i=0;i<r_size;i++)
-  {
-    new_indices[i]+=i;
-    los_region[i]=los[l+i];
-    assume((i==0)||(new_indices[i]>new_indices[i-1]));
-  }
-
-  i=r_size-1;
-  int j=u;
-  int j2=l-1;
-  while(i>=0)
-  {
-    if (new_indices[i]==j)
-    {
-      los[j]=los_region[i];
+      new_indices[i - l] = l;
+    }
+  }
+  red_object *los_region =
+    (red_object *) omalloc (sizeof (red_object) * (u - l + 1));
+  for (int i = 0; i < r_size; i++)
+  {
+    new_indices[i] += i;
+    los_region[i] = los[l + i];
+    assume ((i == 0) || (new_indices[i] > new_indices[i - 1]));
+  }
+
+  i = r_size - 1;
+  int j = u;
+  int j2 = l - 1;
+  while (i >= 0)
+  {
+    if (new_indices[i] == j)
+    {
+      los[j] = los_region[i];
       i--;
       j--;
@@ -4364,33 +4755,34 @@
     else
     {
-      assume(new_indices[i]<j);
-      los[j]=los[j2];
-      assume(j2>=0);
+      assume (new_indices[i] < j);
+      los[j] = los[j2];
+      assume (j2 >= 0);
       j2--;
       j--;
     }
   }
-  omfree(los_region);
-  omfree(new_indices);
+  omfree (los_region);
+  omfree (new_indices);
 }
 
 //assume that los is ordered ascending by leading term, all non zero
-static void multi_reduction(red_object* los, int & losl, slimgb_alg* c)
-{
-  poly* delay=(poly*) omalloc(losl*sizeof(poly));
-  int delay_s=0;
+static void
+multi_reduction (red_object * los, int &losl, slimgb_alg * c)
+{
+  poly *delay = (poly *) omalloc (losl * sizeof (poly));
+  int delay_s = 0;
   //initialize;
-  assume(c->strat->sl>=0);
-  assume(losl>0);
+  assume (c->strat->sl >= 0);
+  assume (losl > 0);
   int i;
-  wlen_type max_initial_quality=0;
-
-  for(i=0;i<losl;i++)
-  {
-    los[i].sev=pGetShortExpVector(los[i].p);
+  wlen_type max_initial_quality = 0;
+
+  for (i = 0; i < losl; i++)
+  {
+    los[i].sev = pGetShortExpVector (los[i].p);
 //SetShortExpVector();
-    los[i].p=kBucketGetLm(los[i].bucket);
-    if (los[i].initial_quality>max_initial_quality)
-        max_initial_quality=los[i].initial_quality;
+    los[i].p = kBucketGetLm (los[i].bucket);
+    if (los[i].initial_quality > max_initial_quality)
+      max_initial_quality = los[i].initial_quality;
     // else
 //         Print("init2_qal=%lld;", los[i].initial_quality);
@@ -4398,123 +4790,130 @@
   }
 
-  int curr_pos=losl-1;
+  int curr_pos = losl - 1;
 
 //  nicht reduzierbare eintrï¿œe in ergebnisliste schreiben
   // nullen loeschen
-  while(curr_pos>=0)
-  {
-    if ((c->use_noro_last_block)&&(lies_in_last_dp_block(los[curr_pos].p,c)))
-    {
-        int pn_noro=curr_pos+1;
-        poly* p_noro=(poly*) omalloc(pn_noro*sizeof(poly));
-        for(i=0;i<pn_noro;i++)
-        {
-            int dummy_len;
-            poly p;
-            los[i].p=NULL;
-            kBucketClear(los[i].bucket,&p,&dummy_len);
-            p_noro[i]=p;
-        }
-        if (npPrimeM<255)
-        {
-          noro_step<tgb_uint8>(p_noro,pn_noro,c);
-        }
-        else
-        {
-          if (npPrimeM<65000)
-          {
-            noro_step<tgb_uint16>(p_noro,pn_noro,c);
-          }
-          else
-          {
-            noro_step<tgb_uint32>(p_noro,pn_noro,c);
-          }
-        }
-        for(i=0;i<pn_noro;i++)
-        {
-            los[i].p=p_noro[i];
-            los[i].sev=pGetShortExpVector(los[i].p);
-            //ignore quality
-            kBucketInit(los[i].bucket,los[i].p,pLength(los[i].p));
-        }
-        qsort(los,pn_noro,sizeof(red_object),red_object_better_gen);
-        int deleted=multi_reduction_clear_zeroes(los, losl, pn_noro, curr_pos);
-        losl -= deleted;
-        curr_pos -= deleted;
-        break;
+  while (curr_pos >= 0)
+  {
+    if ((c->use_noro_last_block)
+	&& (lies_in_last_dp_block (los[curr_pos].p, c)))
+    {
+      int pn_noro = curr_pos + 1;
+      poly *p_noro = (poly *) omalloc (pn_noro * sizeof (poly));
+      for (i = 0; i < pn_noro; i++)
+      {
+	int dummy_len;
+	poly p;
+	los[i].p = NULL;
+	kBucketClear (los[i].bucket, &p, &dummy_len);
+	p_noro[i] = p;
+      }
+      if (npPrimeM < 255)
+      {
+	noro_step < tgb_uint8 > (p_noro, pn_noro, c);
+      }
+      else
+      {
+	if (npPrimeM < 65000)
+	{
+	  noro_step < tgb_uint16 > (p_noro, pn_noro, c);
+	}
+	else
+	{
+	  noro_step < tgb_uint32 > (p_noro, pn_noro, c);
+	}
+      }
+      for (i = 0; i < pn_noro; i++)
+      {
+	los[i].p = p_noro[i];
+	los[i].sev = pGetShortExpVector (los[i].p);
+	//ignore quality
+	kBucketInit (los[i].bucket, los[i].p, pLength (los[i].p));
+      }
+      qsort (los, pn_noro, sizeof (red_object), red_object_better_gen);
+      int deleted =
+	multi_reduction_clear_zeroes (los, losl, pn_noro, curr_pos);
+      losl -= deleted;
+      curr_pos -= deleted;
+      break;
     }
     find_erg erg;
 
-    multi_reduction_find(los, losl,c,curr_pos,erg);//last argument should be curr_pos
-    if(erg.reduce_by<0) break;
-
-    erg.expand=NULL;
-
-    multi_reduction_lls_trick(los,losl,c,erg);
+    multi_reduction_find (los, losl, c, curr_pos, erg);	//last argument should be curr_pos
+    if (erg.reduce_by < 0)
+      break;
+
+    erg.expand = NULL;
+
+    multi_reduction_lls_trick (los, losl, c, erg);
 
     int i;
     //    wrp(los[erg.to_reduce_u].p);
     //PrintLn();
-    multi_reduce_step(erg,los,c);
-
-
-    if(!TEST_OPT_REDTHROUGH)
-    {
-     for(i=erg.to_reduce_l;i<=erg.to_reduce_u;i++)
-     {
-     if  (los[i].p!=NULL)  //the check (los[i].p!=NULL) might be invalid
-     {
-         //
-         assume(los[i].initial_quality>0);
-               if(los[i].guess_quality(c)
-                  >1.5*delay_factor*max_initial_quality)
-                  {
-                       if (TEST_OPT_PROT)
-                           PrintS("v");
-                       los[i].canonicalize();
-                       if(los[i].guess_quality(c)
-                           >delay_factor*max_initial_quality)
-                           {
-                               if (TEST_OPT_PROT)
-                                   PrintS(".");
-                               los[i].clear_to_poly();
-                               //delay.push_back(los[i].p);
-                               delay[delay_s]=los[i].p;
-                               delay_s++;
-                               los[i].p=NULL;
-                      }
-                  }
-            }
-     }
-  }
-    int deleted=multi_reduction_clear_zeroes(los, losl, erg.to_reduce_l, erg.to_reduce_u);
-    if(erg.fromS==FALSE)
-      curr_pos=si_max(erg.to_reduce_u,erg.reduce_by);
+    multi_reduce_step (erg, los, c);
+
+
+    if (!TEST_OPT_REDTHROUGH)
+    {
+      for (i = erg.to_reduce_l; i <= erg.to_reduce_u; i++)
+      {
+	if (los[i].p != NULL)	//the check (los[i].p!=NULL) might be invalid
+	{
+	  //
+	  assume (los[i].initial_quality > 0);
+	  if (los[i].guess_quality (c)
+	      > 1.5 * delay_factor * max_initial_quality)
+	  {
+	    if (TEST_OPT_PROT)
+	      PrintS ("v");
+	    los[i].canonicalize ();
+	    if (los[i].guess_quality (c) > delay_factor * max_initial_quality)
+	    {
+	      if (TEST_OPT_PROT)
+		PrintS (".");
+	      los[i].clear_to_poly ();
+	      //delay.push_back(los[i].p);
+	      delay[delay_s] = los[i].p;
+	      delay_s++;
+	      los[i].p = NULL;
+	    }
+	  }
+	}
+      }
+    }
+    int deleted =
+      multi_reduction_clear_zeroes (los, losl, erg.to_reduce_l,
+				    erg.to_reduce_u);
+    if (erg.fromS == FALSE)
+      curr_pos = si_max (erg.to_reduce_u, erg.reduce_by);
     else
-      curr_pos=erg.to_reduce_u;
+      curr_pos = erg.to_reduce_u;
     losl -= deleted;
     curr_pos -= deleted;
 
     //Print("deleted %i \n",deleted);
-    if ((TEST_V_UPTORADICAL) &&(!(erg.fromS)))
-        sort_region_down(los,si_min(erg.to_reduce_l,erg.reduce_by),(si_max(erg.to_reduce_u,erg.reduce_by))-deleted,c);
+    if ((TEST_V_UPTORADICAL) && (!(erg.fromS)))
+      sort_region_down (los, si_min (erg.to_reduce_l, erg.reduce_by),
+			(si_max (erg.to_reduce_u, erg.reduce_by)) - deleted,
+			c);
     else
-    sort_region_down(los, erg.to_reduce_l, erg.to_reduce_u-deleted, c);
-
-    if(erg.expand)
+      sort_region_down (los, erg.to_reduce_l, erg.to_reduce_u - deleted, c);
+
+    if (erg.expand)
     {
 #ifdef FIND_DETERMINISTIC
       int i;
-      for(i=0;c->expandS[i];i++);
-      c->expandS=(poly*) omrealloc(c->expandS,(i+2)*sizeof(poly));
-      c->expandS[i]=erg.expand;
-      c->expandS[i+1]=NULL;
+      for (i = 0; c->expandS[i]; i++);
+      c->expandS = (poly *) omrealloc (c->expandS, (i + 2) * sizeof (poly));
+      c->expandS[i] = erg.expand;
+      c->expandS[i + 1] = NULL;
 #else
-      int ecart=0;
+      int ecart = 0;
       if (c->eliminationProblem)
       {
-        ecart=c->pTotaldegree_full(erg.expand)-c->pTotaldegree(erg.expand);
-      }
-      add_to_reductors(c,erg.expand,erg.expand_length,ecart);
+	ecart =
+	  c->pTotaldegree_full (erg.expand) - c->pTotaldegree (erg.expand);
+      }
+      add_to_reductors (c, erg.expand, erg.expand_length, ecart);
 #endif
     }
@@ -4523,172 +4922,182 @@
   //sorted_pair_node** pairs=(sorted_pair_node**)
   //  omalloc(delay_s*sizeof(sorted_pair_node*));
-  c->introduceDelayedPairs(delay,delay_s);
+  c->introduceDelayedPairs (delay, delay_s);
   /*
-  for(i=0;i<delay_s;i++)
-  {
-      poly p=delay[i];
-      //if (rPar(c->r)==0)
-      simplify_poly(p,c->r);
-      sorted_pair_node* si=(sorted_pair_node*) omalloc(sizeof(sorted_pair_node));
-      si->i=-1;
-      si->j=-1;
-       if (!rField_is_Zp(c->r))
-       {
-        if (!c->nc)
-            p=redTailShort(p, c->strat);
-        p_Cleardenom(p, c->r);
-        p_Content(p, c->r);
-      }
-      si->expected_length=pQuality(p,c,pLength(p));
-      si->deg=pTotaldegree(p);
-      si->lcm_of_lm=p;
-      pairs[i]=si;
-  }
-  qsort(pairs,delay_s,sizeof(sorted_pair_node*),tgb_pair_better_gen2);
-  c->apairs=spn_merge(c->apairs,c->pair_top+1,pairs,delay_s,c);
-  c->pair_top+=delay_s;*/
-  omfree(delay);
+     for(i=0;i<delay_s;i++)
+     {
+     poly p=delay[i];
+     //if (rPar(c->r)==0)
+     simplify_poly(p,c->r);
+     sorted_pair_node* si=(sorted_pair_node*) omalloc(sizeof(sorted_pair_node));
+     si->i=-1;
+     si->j=-1;
+     if (!rField_is_Zp(c->r))
+     {
+     if (!c->nc)
+     p=redTailShort(p, c->strat);
+     p_Cleardenom(p, c->r);
+     p_Content(p, c->r);
+     }
+     si->expected_length=pQuality(p,c,pLength(p));
+     si->deg=pTotaldegree(p);
+     si->lcm_of_lm=p;
+     pairs[i]=si;
+     }
+     qsort(pairs,delay_s,sizeof(sorted_pair_node*),tgb_pair_better_gen2);
+     c->apairs=spn_merge(c->apairs,c->pair_top+1,pairs,delay_s,c);
+     c->pair_top+=delay_s; */
+  omfree (delay);
   //omfree(pairs);
   return;
 }
 
-void red_object::flatten()
-{
-  assume(p==kBucketGetLm(bucket));
-}
-
-void red_object::validate()
-{
-  p=kBucketGetLm(bucket);
-  if(p)
-    sev=pGetShortExpVector(p);
-}
-
-int red_object::clear_to_poly()
-{
-  flatten();
+void
+red_object::flatten ()
+{
+  assume (p == kBucketGetLm (bucket));
+}
+
+void
+red_object::validate ()
+{
+  p = kBucketGetLm (bucket);
+  if (p)
+    sev = pGetShortExpVector (p);
+}
+
+int
+red_object::clear_to_poly ()
+{
+  flatten ();
   int l;
-  kBucketClear(bucket,&p,&l);
+  kBucketClear (bucket, &p, &l);
   return l;
 }
 
-void reduction_step::reduce(red_object* r, int l, int u){}
-
-void simple_reducer::do_reduce(red_object & ro)
+void
+reduction_step::reduce (red_object * r, int l, int u)
+{
+}
+
+void
+simple_reducer::do_reduce (red_object & ro)
 {
   number coef;
 #ifdef HAVE_PLURAL
   if (c->nc)
-    nc_BucketPolyRed_Z(ro.bucket, p, &coef);
+    nc_BucketPolyRed_Z (ro.bucket, p, &coef);
   else
 #endif
-    coef=kBucketPolyRed(ro.bucket,p,
-       p_len,
-       c->strat->kNoether);
-  nDelete(&coef);
-}
-
-void simple_reducer::reduce(red_object* r, int l, int u)
-{
-  this->pre_reduce(r,l,u);
+    coef = kBucketPolyRed (ro.bucket, p, p_len, c->strat->kNoether);
+  nDelete (&coef);
+}
+
+void
+simple_reducer::reduce (red_object * r, int l, int u)
+{
+  this->pre_reduce (r, l, u);
   int i;
 //debug start
 
-  if(c->eliminationProblem)
-  {
-    assume(p_LmEqual(r[l].p,r[u].p,c->r));
+  if (c->eliminationProblem)
+  {
+    assume (p_LmEqual (r[l].p, r[u].p, c->r));
     /*int lm_deg=pTotaldegree(r[l].p);
-    reducer_deg=lm_deg+pTotaldegree_full(p)-pTotaldegree(p);*/
-  }
-
-  for(i=l;i<=u;i++)
-  {
-    this->do_reduce(r[i]);
+       reducer_deg=lm_deg+pTotaldegree_full(p)-pTotaldegree(p); */
+  }
+
+  for (i = l; i <= u; i++)
+  {
+    this->do_reduce (r[i]);
     if (c->eliminationProblem)
     {
-        r[i].sugar=si_max(r[i].sugar,reducer_deg);
-    }
-  }
-  for(i=l;i<=u;i++)
-  {
-    kBucketSimpleContent(r[i].bucket);
-    r[i].validate();
-    #ifdef TGB_DEBUG
-    #endif
-  }
-}
-
-reduction_step::~reduction_step(){}
-
-simple_reducer::~simple_reducer()
-{
-  if(fill_back!=NULL)
-  {
-    kBucketInit(fill_back,p,p_len);
-  }
-  fill_back=NULL;
-}
-
-void multi_reduce_step(find_erg & erg, red_object* r, slimgb_alg* c)
-{
-  static int id=0;
+      r[i].sugar = si_max (r[i].sugar, reducer_deg);
+    }
+  }
+  for (i = l; i <= u; i++)
+  {
+    kBucketSimpleContent (r[i].bucket);
+    r[i].validate ();
+#ifdef TGB_DEBUG
+#endif
+  }
+}
+
+reduction_step::~reduction_step ()
+{
+}
+
+simple_reducer::~simple_reducer ()
+{
+  if (fill_back != NULL)
+  {
+    kBucketInit (fill_back, p, p_len);
+  }
+  fill_back = NULL;
+}
+
+void
+multi_reduce_step (find_erg & erg, red_object * r, slimgb_alg * c)
+{
+  static int id = 0;
   id++;
   unsigned long sev;
-    BOOLEAN lt_changed=FALSE;
-  int rn=erg.reduce_by;
+  BOOLEAN lt_changed = FALSE;
+  int rn = erg.reduce_by;
   poly red;
   int red_len;
-  simple_reducer* pointer;
-  BOOLEAN work_on_copy=FALSE;
-  if(erg.fromS)
-  {
-    red=c->strat->S[rn];
-    red_len=c->strat->lenS[rn];
-    assume(red_len==pLength(red));
+  simple_reducer *pointer;
+  BOOLEAN work_on_copy = FALSE;
+  if (erg.fromS)
+  {
+    red = c->strat->S[rn];
+    red_len = c->strat->lenS[rn];
+    assume (red_len == pLength (red));
   }
   else
   {
-    r[rn].flatten();
-    kBucketClear(r[rn].bucket,&red,&red_len);
-
-    if (!rField_is_Zp(c->r))
-    {
-      p_Cleardenom(red, c->r);//should be unnecessary
+    r[rn].flatten ();
+    kBucketClear (r[rn].bucket, &red, &red_len);
+
+    if (!rField_is_Zp (c->r))
+    {
+      p_Cleardenom (red, c->r);	//should be unnecessary
       //p_Content(red, c->r);
     }
-    pNormalize(red);
+    pNormalize (red);
     if (c->eliminationProblem)
     {
-        r[rn].sugar=c->pTotaldegree_full(red);
-    }
-
-    if ((!(erg.fromS))&&(TEST_V_UPTORADICAL))
-    {
-         if (polynomial_root(red,c->r))
-            lt_changed=TRUE;
-            sev=p_GetShortExpVector(red,c->r);
-    }
-    red_len=pLength(red);
-  }
-  if (((TEST_V_MODPSOLVSB)&&(red_len>1))||((c->nc)||(erg.to_reduce_u-erg.to_reduce_l>5)))
-  {
-    work_on_copy=TRUE;
+      r[rn].sugar = c->pTotaldegree_full (red);
+    }
+
+    if ((!(erg.fromS)) && (TEST_V_UPTORADICAL))
+    {
+      if (polynomial_root (red, c->r))
+	lt_changed = TRUE;
+      sev = p_GetShortExpVector (red, c->r);
+    }
+    red_len = pLength (red);
+  }
+  if (((TEST_V_MODPSOLVSB) && (red_len > 1))
+      || ((c->nc) || (erg.to_reduce_u - erg.to_reduce_l > 5)))
+  {
+    work_on_copy = TRUE;
     // poly m=pOne();
-    poly m=c->tmp_lm;
-    pSetCoeff(m,nInit(1));
-    pSetComp(m,0);
-    for(int i=1;i<=pVariables;i++)
-      pSetExp(m,i,(pGetExp(r[erg.to_reduce_l].p, i)-pGetExp(red,i)));
-    pSetm(m);
+    poly m = c->tmp_lm;
+    pSetCoeff (m, nInit (1));
+    pSetComp (m, 0);
+    for (int i = 1; i <= pVariables; i++)
+      pSetExp (m, i, (pGetExp (r[erg.to_reduce_l].p, i) - pGetExp (red, i)));
+    pSetm (m);
     poly red_cp;
-    #ifdef HAVE_PLURAL
+#ifdef HAVE_PLURAL
     if (c->nc)
-      red_cp = nc_mm_Mult_pp(m, red, c->r);
+      red_cp = nc_mm_Mult_pp (m, red, c->r);
     else
-    #endif
-      red_cp=ppMult_mm(red,m);
-    if(!erg.fromS)
-    {
-      kBucketInit(r[rn].bucket,red,red_len);
+#endif
+      red_cp = ppMult_mm (red, m);
+    if (!erg.fromS)
+    {
+      kBucketInit (r[rn].bucket, red, red_len);
     }
     //now reduce the copy
@@ -4696,5 +5105,5 @@
 
     if (!c->nc)
-      redTailShort(red_cp,c->strat);
+      redTailShort (red_cp, c->strat);
     //number mul;
     // red_len--;
@@ -4703,45 +5112,48 @@
 //     nDelete(&mul);
 //     red_len++;
-    red=red_cp;
-    red_len=pLength(red);
+    red = red_cp;
+    red_len = pLength (red);
     // pDelete(&m);
   }
 
-  assume(red_len==pLength(red));
-
-  int reducer_deg=0;
+  assume (red_len == pLength (red));
+
+  int reducer_deg = 0;
   if (c->eliminationProblem)
   {
-     int lm_deg=c->pTotaldegree(r[erg.to_reduce_l].p);
-     int ecart;
-     if (erg.fromS)
-     {
-       ecart=c->strat->ecartS[erg.reduce_by];
-     }
-     else
-     {
-       ecart=c->pTotaldegree_full(red)-lm_deg;
-     }
-     reducer_deg=lm_deg+ecart;
-  }
-  pointer=new simple_reducer(red,red_len,reducer_deg,c);
+    int lm_deg = c->pTotaldegree (r[erg.to_reduce_l].p);
+    int ecart;
+    if (erg.fromS)
+    {
+      ecart = c->strat->ecartS[erg.reduce_by];
+    }
+    else
+    {
+      ecart = c->pTotaldegree_full (red) - lm_deg;
+    }
+    reducer_deg = lm_deg + ecart;
+  }
+  pointer = new simple_reducer (red, red_len, reducer_deg, c);
 
   if ((!work_on_copy) && (!erg.fromS))
-    pointer->fill_back=r[rn].bucket;
+    pointer->fill_back = r[rn].bucket;
   else
-    pointer->fill_back=NULL;
-  pointer->reduction_id=id;
-  pointer->c=c;
-
-  pointer->reduce(r,erg.to_reduce_l, erg.to_reduce_u);
-  if(work_on_copy) pDelete(&pointer->p);
+    pointer->fill_back = NULL;
+  pointer->reduction_id = id;
+  pointer->c = c;
+
+  pointer->reduce (r, erg.to_reduce_l, erg.to_reduce_u);
+  if (work_on_copy)
+    pDelete (&pointer->p);
   delete pointer;
   if (lt_changed)
   {
-    assume(!erg.fromS);
-    r[erg.reduce_by].sev=sev;
-  }
-}
-
-void simple_reducer:: pre_reduce(red_object* r, int l, int u){}
-
+    assume (!erg.fromS);
+    r[erg.reduce_by].sev = sev;
+  }
+}
+
+void
+simple_reducer::pre_reduce (red_object * r, int l, int u)
+{
+}
